/*
 * serio.c
 *
 * Created 7/21/94 by Chuck McManis
 *
 * Light weight serial I/O functions for the miniboard.
 * The two of interest are printdec() the miniboard's number
 * printing facility and puts() to print a string.
 */

extern unsigned char getchar();
extern void putchar(unsigned char);

void
puts(s)
	unsigned char *s;
{
	while (*s) {
		putchar(*s);
		s++;
	}
	return;
}

void
numout(n)
	unsigned int n;	/* number to print */
{
	int 	i;
	unsigned int k;
	unsigned char digits[7];

	for (i = 4; i >= 0; i--) {
		k = n/10;
		digits[i] = '0' + (n - (k*10));
		n = k;
	}
	digits[5] = 0;
	puts(digits);
	return;
}

void
printdec(n)
	unsigned int n;
{
	numout(n);
	puts("\n\r");
	return;
}

