/*
 * srvocal.c
 * 
 * Find out what your servo calibration limits should be.
 */
#include <hc11.h>
#include <mboard.h>
#define WANT_SERVOS
#include <mbintsvc.h>

#define NEUTRAL 3040

main()
{
	unsigned char	c;
	unsigned int	pos;
	int	srvo_num;

	srvo_num = 1;
	servo(srvo_num, 0);	/* Neutral Position */
	pos = NEUTRAL;
	PACTL |= 0x80;
	while(1) {
		c = getchar();
		switch (c) {
		case '1':
			srvo_num = 1;
			break;
		case '2':
			srvo_num = 2;
			break;
		case '3':
			srvo_num = 3;
			break;
		case 'N':
		case 'n':
			pos = NEUTRAL;
			servo_position[srvo_num - 1] = pos;
			break;
		case '-':
			pos = pos - 1;
			servo_position[srvo_num - 1] = pos;
			break;
		case '_' : 
			pos = pos - 10;
			servo_position[srvo_num - 1] = pos;
			break;
		case '=' : 
			pos = pos + 1;
			servo_position[srvo_num - 1] = pos;
			break;
		case '+' :
			pos = pos + 10;
			servo_position[srvo_num - 1] = pos;
			break;
		case 'Q' :
		case 'q' :
			servo_off(srvo_num);
			break;
		default:
			putchar(0x7);
			break;
		}
		puts("\r\n\tServo #");
		putchar(srvo_num + '0');
		puts(" position: ");
		printdec(servo_position[srvo_num - 1]);	
	}
}
