/*
 * Servo Slave
 *
 * This simple program slaves a servo to an analog input. An interesting
 * use for this type of program is to mix the ouputs of two CDS photocells
 * thru an op amp and into the analog input. If you attach the CDS cells
 * to the servo then you can make the servo always point at the brightest
 * light source.  
 */
#define WANT_SERVOS
#include <mboard.h>
#include <mbintsvc.h>

/*
 * Set this based on your analog source, these happen to work for a 100K
 * pot I had in a joy stick.
 */
#define ANALOG_MIN	8
#define ANALOG_MAX	193
#define ANALOG_MID	((ANALOG_MAX - ANALOG_MIN)/2)
main()
{
	int	c;
	int	pos;

	pos = 0;
	servo(2, pos);	/* 50 % point */
	while(1) {
		c = analog(2);
		pos = (((c - ANALOG_MIN) - ANALOG_MID) * 100) / ANALOG_MID;
		if (pos > 100) pos = 100;
		if (pos < -100) pos = -100;
		servo(2, pos);
	}
}
