/************************************************************************
 * 			MEKATRONIX Copyright 1998 		        *
 * Title        irtj.h                                                  *
 * Programmer   Keith L. Doty                                           *
 * Date         March 10, 1998                                          *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *   This header file refers to all routines necessary for IR emitter   *
 *   control and reading IR detector inputs. Object file is in libtj.a  *
 ************************************************************************/

#ifndef _IRMOD_H
#define _IRMOD_H

/**************************** Includes **********************************/

#include <hc11.h>
#include <mil.h>

/**************************** End of Includes ***************************/


/***************************** Prototypes *******************************/

void irmod32(void); /* Modulates IR emitters at 32KHz */
void irmod40(void); /* Modulates IR emitters at 40KHz */
void init_ir(void); /* Initializes IR parameters */
int ir_value(int);  /* Reads IR detectors */
void ir_mode(int);
  /* Switches between self and other for IR light source */

void discharge(void);
/* Forces zeros into IR detector readings for about 100ms. This allows the IR
 * detector circuitry time to reach a final value before the next reading.
 */

#endif
