/************************************************************************
 * 			MEKATRONIX Copyright 1998 		        *
 * Title        mil.h                                                   *
 * Programmer   Keith L. Doty                                           *
 * Date         March 10, 1998                                          *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *   A collection of functions that operate on MC68HC11 registers.      *
 *   Object file is in libtj.a                                          *
 ************************************************************************/

#ifndef _MIL_H
#define _MIL_H

#define CLEAR_BIT(x,y) x &= ~y;
/* Clear all bits in x corresponding to the bits set in y.
 * The other bits in x are not affected.
*/

#define SET_BIT(x,y) x |= y;
/* Set all bits in x corresponding to the bits set in y.
 * The other bits in x are not affected.
*/

#define CLEAR_FLAG(x,y) x &= y;
/* USE this routine ONLY for clearing flags. Clears flags in x corresponding
 * to the bits set in y. Other flags in x are not affected.
 */


#endif
