/************************************************************************
 * 			MEKATRONIX Copyright 1998 		        *
 * Title        clocktj.h                                               *
 * Programmer   Keith L. Doty                                           *
 * Date         March 10, 1998                                          *
 * Version      1                                                       *
 *                                                                      *
 * Description								*
 *	This header file refers to all routines and interrupt drivers   *
 *      necessary for TJ clock control. The clock keeps track of        *
 *      milliseconds, seconds, minutes, hours, days and timertj.			*
 ************************************************************************/


/**************************** Includes **********************************/
#include <hc11.h>
#include <mil.h>
/************************************************************************/

/*************************** Prototypes *********************************/

#pragma interrupt_handler TOC5_isr
void TOC5_isr(void); /*Interrupt service routine to generate clock ticks*/
void init_clocktj(void);
void wait(int);   /* Wait for int milliseconds */

/************************************************************************/


/***************************** Globals **********************************/

unsigned int msec, seconds, minutes, hours, days, timertj;

/************************************************************************/

