; Do not define any .area above this line. .text must be the first
; line in this file.  You may put .area(s) at the end of the file.
;
; You need to define two symbols on the link command line
;	init_sp		: initial stack pointer
;	heap_size 	: size of heap
; If you have HC11 specific setup that you need to perform in the first
; 64 cycles, define it in a routine called __HC11Setup (single _ if 
; written in C) and link it with your program.
; The entry point of your program is _start, which is defined here.
;
	.text
__start::			; entry point
	lds	#init_sp
	jsr	__HC11Setup	; define your own HC11 rtn if you want to do
					; initialization stuff at the first 64 cycles
					; after reset.
; clear BSS
	clra
	ldx	#__bss_start
init_loop:
	cpx	#__bss_end
	beq	init_done
	staa	0,x
	inx
	bra	init_loop

init_done:
; set up heap space
	ldd	#heap_size
	beq	heap_done
	addd #__bss_end
	pshb
	psha
	ldd	#__bss_end
	jsr	__NewHeap
	pulx
heap_done:
; call user main routine
	jsr _main
_exit::
	bra	_exit
	.data
__data_start::
	.area bss
__bss_start::
