;
;
;*****************************************************************************
;                                                                            *
;                        FLOATING POINT EXP(X) AND 10^X                      *
;                                                                            *
;*****************************************************************************
;
;
	.area	text
_exp10::
	pshb
	psha
	tsx
	ldab	#4
	abx
	jsr		__to_fpacc1
	bsr		FLT10TX
	tsx
	pulx
	jsr		__from_fpacc1
	rts

_exp::
	pshb
	psha
	tsx
	ldab	#4
	abx
	jsr		__to_fpacc1
	bsr		FLTETOX
	tsx
	pulx
	jsr		__from_fpacc1
	rts

FLT10TX:  ;
         jsr    __push_fpacc2     ;SAVE FPACC2
         ldx    #N1DLN10     ;POINT TO 1/LN(10)
         jsr    __to_fpacc2     ;PUT IT IN FPACC2
         jsr    __fpdiv       ;COMPUTE LOG BASE 10
         jsr    __pull_fpacc2     ;RESTORE FPACC2
FLTETOX:  ;
         ldd    __fpacc1_exp     ;GET ARGUMENT EXPONENT AND MANTISSA MSB
         cpd    #0x85B3      ; CHECK FOR ARGUMENT IN RANGE (< 89.0)
         bmi    FLTETOX1     ;IN RANGE
         tst    __fpacc1_mantissa_sign     ;CHECK FOR NEGATIVE ARGUMENT
         bne    FLTETOX0     ;NEGATIVE ARGUMENT - UNDERFLOW
         jmp    __fp_return_max       ;OVERFLOW
FLTETOX0: jmp    __fp_return_zero     ; UNDERFLOW
FLTETOX1: jsr    __push_fpacc2    ; SAVE FPACC2
         ldaa   __fpacc1_mantissa_sign     ;SAVE SIGN OF ARGUMENT FOR LATER
         psha
         clr    __fpacc1_mantissa_sign     ;WORK WITH POSITIVE ARGUMENT
         jsr    __fp_intfrac      ;SEPARATE IT INTO INTEGRAL AND FRACTIONAL PARTS
         ldd    __fpacc2_exp     ;GET EXPONENT OF INTEGER IN A; MANTISSA IN B
         beq    FLTETOX6     ;IF NO INTEGRAL PART OF ARGUMENT
         suba   #0x86        ; SET UP SHIFT COUNTER
FLTETOX5: lsrb               ; SHIFT TO DENORMALIZE INTEGER
         inca                ;INCREMENT COUNTER
         bne    FLTETOX5     ;IF NOT FINISHED SHIFTING
FLTETOX6: incb               ; INTEGRAL PART OF ARG BECOMES ITERATION COUNTER
         pshb                ;SAVE INTEGRAL PART FOR NOW
         ldx    #ETOXTBL     ;POINT TO COEFFICIENT TABLE
         jsr    POLYNOM      ;EVALUATE FRACTIONAL PART OF E^X
         ldx    #NCONSTE     ;POINT TO CONSTANT E (2.71828)
         jsr    __to_fpacc2     ;PUT IT INTO FPACC2
         bra    FLTETOX2     ;GO DO MULTIPLICATION ITERATION
FLTETOX3:jsr    __fpmul      ; MULTIPLY RESULT BY E
FLTETOX2:tsx                ; GET BACK POINTER TO ITERATION COUNTER
         dec    0,x          ;DECREMENT ITERATION COUNTER
         bne    FLTETOX3     ;IF ITERATION COUNTER NOT ZERO, KEEP GOING
         pula                ;DISCARD ITERATION COUNTER
         pula                ;RETRIEVE SIGN OF ORIGINAL ARGUMENT
         tsta                ;WAS IT POSITIVE?
         bpl    FLTETOX4     ;YES - DONE
FLTRCP1: jsr    __fp_xfer_acc1_to_acc2     
				; TAKE RECIPROCAL OF RESULT - MOVE IT TO FPACC2
         ldx    #ONE         ;POINT TO CONSTANT 1.0
         jsr    __to_fpacc1     ;PUT IT IN FPACC1
         jsr    __fpdiv       ;TAKE RECIPROCAL
FLTETOX4: jsr    __pull_fpacc2    ; RESTORE FPACC2
         clrb                ;NO ERRORS
         rts                 ;RETURN
;
FLTRECIP:: ;
         jsr    __push_fpacc2     ;SAVE FPACC2
         bra    FLTRCP1      ;DO RECIPROCAL
;
NCONSTE:  .byte    0x40,0x2D,0xF8,0x54
;
ETOXTBL:  ;
         .byte    0x36,0x38,0xEF,0x1D         ;+(1/9!)
         .byte    0x37,0xD0,0x0D,0x01         ;+(1/8!)
         .byte    0x39,0x50,0x0D,0x01         ;+(1/7!)
         .byte    0x3A,0xB6,0x0B,0x61         ;+(1/6!)
         .byte    0x3C,0x08,0x88,0x89         ;+(1/5!)
         .byte    0x3D,0x2A,0xAA,0xAB         ;+(1/4!)
         .byte    0x3E,0x2A,0xAA,0xAB         ;+(1/3!)
CONSTP5: .byte    0x3F,0x00,0x00,0x00        ; +(1/2!)
         .byte    0x3F,0x80,0x00,0x00         ;+(1/1!)
         .byte    0x3F,0x80,0x00,0x00         ;+(1/0!)
         .byte    0xFF
;
;
;*****************************************************************************
;                                                                            *
;                        FLOATING POINT X ^ Y                                *
;                                                                            *
;        X is in FPACC1, Y is in FPACC2                                      *
;                                                                            *
;*****************************************************************************
;
;
_pow::
	pshb
	psha
	tsx
	ldab	#4
	abx
	jsr		__to_fpacc1
	tsx
	ldab	#8
	abx
	jsr		__to_fpacc2
	bsr		FLTXTOY
	tsx
	pulx
	jsr		__from_fpacc1
	rts
FLTXTOY:  ;
         jsr    FLTLN
         jsr    __fpmul
         jmp    FLTETOX
