;*****************************************************************************
;                                                                            *
;                        FLOATING POINT NATURAL LOG AND LOG BASE 10          *
;                                                                            *
;*****************************************************************************
;
;
	.area	text
_log10::
	pshb
	psha
	tsx
	ldab	#4
	abx
	jsr		__to_fpacc1
	bsr		FLTLGT
	tsx
	pulx
	jsr		__from_fpacc1
	rts

FLTLGT:   ;
         bsr    FLTLN        ;FIRST FIND NATURAL LOG
         jsr    __push_fpacc2     ;SAVE FPACC2
         ldx    #N1DLN10     ;POINT TO 1/LN(10)
         jsr    __to_fpacc2     ;PUT IT IN FPACC2
         jsr    __fpmul       ;COMPUTE LOG BASE 10
         jsr    __pull_fpacc2     ;RESTORE FPACC2
         clrb                ;NO ERRORS
         rts                 ;DONE
;
_log::
	pshb
	psha
	tsx
	ldab	#4
	abx
	jsr		__to_fpacc1
	bsr		FLTLN
	tsx
	pulx
	jsr		__from_fpacc1
	rts
FLTLN::
         ldaa   __fpacc1_mantissa_sign     ;CHECK FOR NEGATIVE
         beq    LN1          ;NOT NEGATIVE
LN0:      ldaa   #LNNEGERR   ; NEGATIVE OR ZERO ARGUMENT RETURN
         sec                 ;SIGNAL ERROR
         rts                 ;RETURN
LN1:      ldaa   __fpacc1_exp    ; CHECK FOR ZERO
         beq    LN0          ;ZERO - RETURN ERROR
         jsr    __push_fpacc2     ;SAVE ACCUMULATOR 2
         pshx                ;CREATE STACK STORAGE SPACE FOR INTERMEDIATE RESULT
         pshx
         tsx                 ;CREATE POINTER TO INTERMEDIATE RESULT
         jsr    __from_fpacc1     ;SAVE ARGUMENT
         clra                ;GET EXPONENT OF ARGUMENT INTO D TO CONVERT ...
         ldab   __fpacc1_exp     ;... TO FLOATING POINT.
         subb   #0x7F        ; CONVERT EXPONENT FROM EXCESS 127 TO 2'S COMPLEMENT
         bpl    LN2          ;IF EXPONENT IS POSITIVE, NO NEED TO EXTEND SIGN
         coma                ;EXTEND SIGN THROUGH MSB OF D REGISTER
LN2:      jsr    __int_to_fp    ; DO INTEGER TO FLOATING POINT CONVERSION
         ldx    #NLN2        ;POINT TO CONSTANT LN(2)
         jsr    __to_fpacc2     ;PUT IT INTO FPACC2
         jsr    __fpmul       ;NOW HAVE PART OF ANSWER DEPENDENT ON EXPONENT
         tsx                 ;GET BACK TEMPORARY STORAGE POINTER
         jsr    __to_fpacc2     ;LOAD ORIGINAL ARGUMENT
         jsr    __from_fpacc1     ;SAVE PARTIAL RESULT
         ldaa   #0x7F        ; SINCE WE HAVE LOG OF EXPONENT, TAKE LOG OF ...
         staa   __fpacc2_exp     ;... MANTISSA WITH ZERO EXPONENT.
         pshx                ;CREATE STORAGE SPACE FOR MANTISSA
         pshx
         tsx                 ;GET POINTER TO NEW STORAGE
         jsr    __from_fpacc2     ;SAVE MANTISSA (M)
         ldx    #ONE         ;POINT TO CONSTANT ONE
         jsr    __to_fpacc1     ;PUT IT INTO FPACC1
         jsr    __fpadd       ;(M+1)
         tsx                 ;GET MANTISSA POINTER BACK
         jsr    __to_fpacc2     ;(M)
         jsr    __from_fpacc1     ;(M+1)
         ldx    #MONE        ;POINT TO CONSTANT MINUS ONE
         jsr    __to_fpacc1     ;PUT IT INTO FPACC1
         jsr    __fpadd       ;(M-1)
         tsx                 ;GET POINTER TO (M+1)
         jsr    __to_fpacc2     ;PUT IT INTO FPACC2
         jsr    __fpdiv       ;(M-1)/(M+1)
         tsx                 ;POINT TO TEMPORARY STORAGE
         jsr    __from_fpacc1     ;SAVE POWER SERIES VARIABLE
         jsr    __fp_xfer_acc1_to_acc2      ;PUT POWER SERIES VARIABLE INTO FPACC2
         jsr    __fpmul       ;SQUARE IT
         ldx    #LNTBL       ;POINTER TO POLYNOMIAL COEFFICIENTS
         jsr    POLYNOM      ;COMPUTE POWER SERIES RESULT
         tsx                 ;GET POINTER TO (M-1)/(M+1)
         jsr    __to_fpacc2     ;PUT IN FPACC2
         jsr    __fpmul       ;MULTIPLY TO GET LOG OF MANTISSA
         pulx                ;DISCARD (M-1)/(M+1)
         pulx
         tsx                 ;GET POINTER TO LOG OF EXPONENT
         jsr    __to_fpacc2     ;PUT IN FPACC2
         jsr    __fpadd       ;ADD TO GET COMPLETE LOG RESULT
         pulx                ;DISCARD LOG OF EXPONENT
         pulx
         jsr    __pull_fpacc2     ;RESTORE FPACC2
         clrb                ;NO ERRORS
         rts                 ;RETURN.
;
; FLTSGN:   ;
;          tst    __fpacc1_mantissa    ; CHECK FOR ZERO
;          beq    FLTSGNZ     ; DO NOTHING IF ZERO
;          ldd    #0x7F80     ;  MANTISSA/EXPONENT IS 1.000
;          std    __fpacc1_exp    ; SAVE EXPONENT AND MANTISSA HIGH BYTE
; FLTSGNZ:  clra              ;  MID BYTE IS ZERO
;          clrb               ; LOW BYTE IS ZERO
;          std    __fpacc1_mantissa+1  ; SAVE MANTISSA LOW BYTES
;          rts
