#include <stdio.h>
#include <stdarg.h>

/*
char *gets(char *s)
	{
	char *r = s;
	int c;

	while ((c = getchar()) != 0)
		*s++ = c;
	*s = 0;
	return r;
	}
*/
	
void _itoa(char *buf, unsigned int i, int base)
	{
	char *s;
#define LEN	10
	int rem;
	static char rev[LEN+1];

	if (i == 0)
		s = "0";
	else
		{
		rev[LEN] = 0;
		s = &rev[LEN];
		while (i)
			{
			rem = i % base;
			if (rem < 10)
				*--s = rem + '0';
			else if (base == 16)
				*--s = "abcdef"[rem - 10];
			i /= base;
			}
		}
	strcpy(buf, s);
	}

int _print(char **ps, void (*_put)(char **, int), char *fmt, va_list va)
	{
	char buf[10];
	char *bp;
	char *s;
	int i;
	int ret = 0;
	int prefix;

	while (*fmt)
		{
		bp = buf;
		
		if (*fmt != '%')
			{
			(*_put)(ps, *fmt);
			ret++;
			}
		else
			{
			if (fmt[1] == '#' && (fmt[2] == 'o' || fmt[2] == 'x'))
				++fmt, prefix = 1;
			else
				prefix = 0;
			switch (*++fmt)
				{
			case 'd':
				i = va_arg(va, int);
				if (i < 0)
					{
					*bp++ = '-';
					i = -i;
					}
				_itoa(bp, i, 10);
				s = buf;
				goto print_string;
			case 'u':
			case 'o':
			case 'x':
				i = va_arg(va, unsigned int);
				if (*fmt == 'u')
					_itoa(bp, i, 10);
				else if (*fmt == 'o')
					{
					if (prefix)
						*bp++ = '0';
					_itoa(bp, i, 8);
					}
				else
					{
					if (prefix)
						{
						*bp++ = '0';
						*bp++ = 'x';
						}
					_itoa(bp, i, 16);
					}
				s = buf;
				goto print_string;
			case 'c':
				i = va_arg(va, int);
				(*_put)(ps, i);
				ret++;
				break;
			case 's':
				s = va_arg(va, char *);
				if (!s)
					s = "(null ptr passed)";
			print_string:
				while (*s)
					{
					(*_put)(ps, *s++);
					ret++;
					}
				break;
			case 'f':
#ifdef FLOAT_PRINTF
				{
				int i;
				float f = va_arg(va, float);
				extern char *_fp_buf();

				s = _fp_buf(f);
				/* fp_to_string does not give format that C users are
				 * used to. Convert.
				 */
				if (s[1] == '.')
					{
					if (s[0] == ' ')
						s[0] = '0';
					else if (s[0] == '-')
						{
						buf[0] = '-';
						buf[1] = '0';
						strcpy(&buf[2], &s[1]);
						s = buf;
						}
					}
				else if (s[0] == ' ')
					s++;
				i = strlen(s);
				if (s[i-1] == '.')
					{
					s[i] = '0';
					s[i+1] = 0;
					}
				}
#else
				s = "<integer only print>";
#endif
				goto print_string;

				}
			}
		fmt++;
		}
	return ret;
	}
