echo off
echo ********************************************************************
echo * Make sure to set your mode switch into Download (Bootstrap) Mode *
echo *  and to push the RESET button on your Mekatronix MSCC11 board.     *
echo ********************************************************************
echo If you're ready, 
pause

if "%1"=="" goto noargument
set nofile=true
if exist %1 set nofile=false
if exist %1.s19 set nofile=false
if %nofile%==true goto wrongfile
if not exist mscc11.mcr goto nomacro
if "%2"=="" goto Port1
pcbug11 -a port=%2 macro=mscc11 (%1)
goto display
:Port1
echo *COM1 taken as default *
pcbug11 -a port=1 macro=mscc11 (%1)
:display
echo ******************************************************************
echo  Note: If you see the DOS error message "Bad command or file     * 
echo        name", you need to copy PCBUG11.EXE into the current path.*
echo ******************************************************************
echo * If you did not see any errors while setting up or downloading, *
echo *   then set robot mode switch into Run Mode.                    *
echo * You are now ready to execute your program by pressing RESET    *
echo *   button on your robot. Careful! Suspend the robot wheels in   *
echo *   space or place the robot on the floor before pressing Reset! *
echo ******************************************************************
goto end
:noargument
echo MSCC11.bat is a batch file to do the followings:
echo   1. Set up Mekatronix MSCC11 board ready for Download 
echo   2. Download S19 file into Mekatronix MSCC11 board
echo *********************************
echo * Usage: mscc11 S19_File PortNo *
echo *********************************
echo   S19_File: S19 Filename (You don't need to include extension .s19)
echo   PortNo: Communication Port Number
echo           1 for COM1
echo           2 (Default) for COM2
echo           3 for COM3
echo           4 for COM4
echo (Example 1) Download test.s19 under c:\s19files\test.s19 via COM2
echo    mscc11 c:\s19files\test     
echo (Example 2) Download test2.s19 under the current directory via COM1
echo    mscc11 test2 1    
goto end
:wrongfile
echo **********************************************************************
echo  Error: Cannot find the filename 
echo              %1 or %1.s19     
echo         Check your file and try again.            
echo **********************************************************************
goto end
:nomacro
echo **********************************************************************
echo  Error: Cannot find MSCC11.MCR under the current directory. 
echo         Copy MSCC11.MCR into the current directory.
echo **********************************************************************
goto end
:end 
echo ** End of MSCC.BAT execution **

