/*
   base_tj.c

   Talrik Junior base program

   (c) Jorge Lobo 2000

 */

#include <tjbase.h>

/* for infra-red sensors  */
#define RIGHT_EYE  6
#define LEFT_EYE  7

/* state machine */
#define ST1_STOP     1
#define ST2_FORWARD   2
#define ST3_BACKTURN 3


void delay(void){
int i;
/* T= 27*(i-1)+24 cycles,cycle = 0.5 microseconds */ 
/* i=((T-24)/27 + 1 )*2, T in microseconds*/
  for(i = 1; i < 741; i++);   /* T = 0.01 seconds */
}

void longdelay(void){
int i;
/* T= 27*(i-1)+24 cycles,cycle = 0.5 microseconds */ 
/* i=((T-24)/27 + 1 )*2, T in microseconds*/
  for(i = 1; i < 37037; i++);   /* T = 0.5 seconds */
  for(i = 1; i < 37037; i++);   /* T = 0.5 seconds */
}

void delayn(unsigned n){
int i;
  for(i = 1; i < n; i++);
}

main(void)
{
  int state;
  unsigned random;

  init_motortj();
  init_analog();
  init_ir();
 
  DDRC = 0x00;           /* Set PORTC (bumper) for input */

  state=ST1_STOP;

  while(1)
  {
   delay();
   switch(state){
	case 	 ST1_STOP:
				      motortj(LEFT_MOTOR, 0);
				      motortj(RIGHT_MOTOR, 0);
					  if(PORTC & 0x01)
						state=ST2_FORWARD;
					  longdelay();
				  	  break;
	case  ST2_FORWARD:
 				       motortj(LEFT_MOTOR, 100);
				       motortj(RIGHT_MOTOR, 100);
					   if(PORTC & 0x20)
					 	state=ST3_BACKTURN;
					   else if(PORTC & 0x01){
				        motortj(LEFT_MOTOR, 0);
				        motortj(RIGHT_MOTOR, 0);
						state=ST1_STOP;
					    longdelay();						
					   }
				  	  break;
	case ST3_BACKTURN:
				      motortj(LEFT_MOTOR, -100);
				      motortj(RIGHT_MOTOR, -100);
				      longdelay();
				      random=TCNT;
				      if(random & 0x0001){
				        motortj(LEFT_MOTOR, 100);
				        motortj(RIGHT_MOTOR, -100);
				      }
				      else {  
				        motortj(LEFT_MOTOR, -100);
				        motortj(RIGHT_MOTOR, 100);
				      }  
				      delayn(random);
				      state=ST2_FORWARD;				      
				  	  break;
   }

/*
    irdr = ir_value(RIGHT_EYE);
    irdl = ir_value(LEFT_EYE);

    if (irdr > 100)
      rspeed = BACKR;
    else
      rspeed = FORWR;
    if (irdl > 100)
      lspeed = BACKL;
    else
      lspeed = FORWL;

    motortj(RIGHT_MOTOR, 0); 
    motortj(LEFT_MOTOR, 0);


    if(PORTC & 0x20)
    {
      motortj(LEFT_MOTOR, BACKL);
      motortj(RIGHT_MOTOR, BACKR);
      for(i = 0; i < 25000; i++);
      turn();
    }
*/

  }    
}

