/**********************************************************************
*                        MEKATRONIX Copyright 1998
*
* Title        sensortj.c
* Programmer   Keith L. Doty
* Date         March 30, 1998
* Version 

* Description 
This program outputs the values of the IR detectors and the bumper switches.

* Usage
Type any character to get a new sample of the sensor readings.

Serial Protocol of this program:
  baud=9600, 8 data bits, 1 stop bit, no parity, no flow control.
 
 Example: 
   Configure Hyperterm on Win95:
   Direct to COM1, 9600 baud, 8 bits, no parity, 1 stop bit,
   no flow control.

**********************************************************************/

/*************************** Includes ********************************/

#include <tjbase.h>

/************************ End of Includes ****************************/


/*************************** Constants **********************************/

#define CR 13
#define LF 10

/************************ End of Constants ******************************/


/***************************** Main **********************************/
main()
{
  int c;
  init_serial();
  init_motortj();
  init_analog();
  init_ir();
  
  DDRC = 0x00;           /* Set PORTC (bumper) for input */

  while(1)
  {
    write("TALRIK JUNIOR SENSOR READINGS");
          put_char(CR); 
	  put_char(LF);
	  put_char(CR); 
	  put_char(LF);
    write("Left IR       "); write_int(ir_value(6));
    write("Right IR      "); write_int(ir_value(7)); 
    write("Front Bumper  "); if(PORTC & 0x20)  write("ON"); else write("OFF");
	  put_char(CR); 
	  put_char(LF);
    write("Rear Bumper   "); if(PORTC & 0x01)  write("ON"); else write("OFF");
	  put_char(CR); 
	  put_char(LF);
	  put_char(CR); 
	  put_char(LF);
    write("Type any character to take another sensor suite reading.");
	  put_char(CR); 
	  put_char(LF);
	  put_char(CR); 
	  put_char(LF);
    c = get_char();
  }   
}
/************************** End of Main ******************************/
